/* include/structs.h - Dclaration des diffrentes structures
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//------------------- Structures robot -------------------
struct robot {
  char server[150];
#ifdef N2K
  char servnum[3];
#else
  char servnum[2];
#endif
  int num;
  char pass[150];
  int port;
  char name[100];
  char ip[30];
  char chan[201];
  char cara;
  int sock;
  int ipnum;
};

struct bots {
  char nick[NICKLEN];
  char ident[USERLEN];
  char host[HOSTLEN];
  char name[REALEN];
  char chan[201];
  char mode[10];
#ifdef N2K
  char num[6];
#else
  char num[4];
#endif
  int actif;
};

//------------------- Structures informations serveurs -------------------

struct Link {
	char serv[200];
#ifdef N2K
	char num[3];
#else
	char num[2];
#endif
	int flag;
#define ST_BURST 0x01
#define ST_ONLINE 0x02
#define ISHUB 0x04
	struct Link *next;
	struct Link *last;
	struct Link *hub;
};

//------------------- Structures users et accs -------------------
typedef struct nickinfo {
   char nick[NICKLEN];
   char ident[USERLEN];
   char host[HOSTLEN];
#ifdef HAVE_CRYPTHOST
   char crypt[HOSTLEN];
#endif
   char server[100];
   char name[REALEN];
   char base64[6];
#ifdef N2K
   char numeric[6];
#else
   char numeric[4];
#endif
   char modes[15];
   int flag;
#define N_REGISTER		 0x001
#define N_AWAY 			0x002
#define N_OPER 			0x004
   long ttmco;
   long floodtime;
   int floodcount;
   struct userinfo *user;
   struct nickinfo *next;
   struct nickinfo *last;
   struct joininfo *joinhead;
} aNick;

typedef struct userinfo {
   char nick[NICKLEN];
   char passwd[20];
   int level;
   int lastseend;
   int flag;
#ifdef USE_NICKSERV
#define U_KILL		 0x001
#define U_PROTECT	 0x002
#endif
#define U_WANTDROP	 0x004
#define U_NOPURGE	 0x008
#define U_WANTX		 0x010
#define U_OUBLI		 0x020
#define U_FIRST 	 0x040
#define U_NOMEMO	 0x080
#define U_PREJECT	 0x100
#define U_POKACCESS	 0x200
#define U_PACCEPT	 0x400
   int suspendu;
   char mail[150];
#ifdef HAVE_VOTE
   int vote;
#endif
   struct access *accesshead;
   struct nickinfo *n;
   struct waitaccess *wahead; // access en liste d'attente
#ifdef USE_MEMOSERV
   struct memos *memohead;
#endif
   struct userinfo *next;
   struct userinfo *last;
} anUser;

typedef struct joininfo
{
   char channel[201];
   int is_op;
   int is_voice;
   char modes[100];
   long timestmp;
   struct nickinfo *nick;
   struct joininfo *next;
} aJoin;

typedef struct access {
   char chan[200];
   int level;
   int flag;
#define A_OP		 0x01
#define A_VOICE		 0x02
#define A_PROTECT	 0x04
#define A_SUSPEND	 0x08
   long lastseen;
   char info[200];
   struct chaninfo *c; // pour rediriger vers la struct du chan o on a access.
   struct userinfo *user;
   struct access *next;
} anAccess;

typedef struct waitaccess { // access en liste d'attente
   char chan[200];
   int level;
   struct waitaccess *next;
} aWaitAccess;

#ifdef USE_MEMOSERV
typedef struct memos {
   char de[NICKLEN];
   int date;
   char message[MEMOLEN];
   struct memos *next;
} aMemo;
#endif

struct badnicks {
	char chaine[NICKLEN];
	struct badnicks *next;
};

//------------------- Structures chans -------------------
struct badchans {
	char chaine[100];
	char raison[150];
	struct badchans *next;
};

typedef struct chaninfo {
	char chan[200];
	char modes[20];
	char topic[TOPICLEN];
	char defmodes[30];
	char deftopic[TOPICLEN];
	char welcome[250];
	char description[200];
	char suspend[200];
	char motd[250];
	char url[200];
	char key[100];
	int flag;
#define C_SETWELCOME	0x001
#define C_JOINED	0x002
#define C_STRICTOP	0x004
#define C_LOCKTOPIC	0x008
#define C_NOBANS	0x010
#define C_WANTUNREG	0x020
#define C_NOOPS		0x040
#define C_AUTOINVITE 0x080
	int banlevel;
	int bantype;
	long chanstamp;
	struct baninfo *banhead;
	struct SLink *access; // utiliser un link pour avoir la liste des access plus rapidement
	struct SLink *members; // listes ds users dans le chan
	struct chaninfo *next;
} aChan;

typedef struct baninfo {
	char mask[100];
	char raison[300];
	char de[NICKLEN];
	long debut;
	long fin;
	int level;
	struct baninfo *next;
} aBan;

struct welcomeinfo {
	int id;
	char msg[250];
	int level;
	struct welcomeinfo *next;
};

//------------------- Structures flood et kill -------------------
typedef struct killinfo
{
   char nick[NICKLEN];
   char numeric[8];
   long timestamp;
   int why;
   int setkill;
   struct killinfo *next;
} aKill;

struct ignore
{
	char host[HOSTLEN];
	long exp;
	struct ignore *next;
};

#ifdef HAVE_VOTE
struct votes
{
	char prop[200];
	int voies;
};
#endif

#ifdef HAVE_TRACK
struct track
{
	aNick *tracker;
	anUser *tracked;
	long from;
	long expire;
	struct track *next;
};
#endif

//------------------- Structures conf, parses et cmds -------------------
struct aConfPara {
  char *name;
  int flag;
  char *syntax;
};

struct aMsg {
  char *cmd;
  void (*func) (int sock, int parc, char **parv);
};

struct cs_commands {
   char cmd[15];
   void (*func) (aNick *nick, aChan *chaninfo, int parc, char **parv);
   char syntax[250];
   int level;
   int args;
   int chan;
   int disable;
   int secure;
   int used;
   char realcmd[15];
};

//------------------- Structures pour les Links -------------------

typedef struct SLink {
  struct SLink *next;
  union {
    anAccess *a;
    aJoin *j;
  } value;
} aLink;
