/* include/structs.h - Dclaration des diffrentes structures
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

struct w2c_clientinfo {
	int socket;
	char ip[256];
	int flag;
	struct w2c_clientinfo *next;
};

 struct w2c_commands {
   char cmd[15];
   void (*func) (struct w2c_clientinfo *cli, int parc, char **parv);
   int level;
   int args;
   int chan;
};


/* Prototypes */
void w2c_parsemsg(struct w2c_clientinfo *, char *);
void w2c_login(struct w2c_clientinfo *, int, char **);
void w2c_pong(struct w2c_clientinfo *, int, char **);
void w2c_moduser(struct w2c_clientinfo *, int, char **);
void w2c_chaninfo(struct w2c_clientinfo *, int, char **);
void w2c_access(struct w2c_clientinfo *, int, char **);
void w2c_set(struct w2c_clientinfo *, int, char **);
void w2c_user(struct w2c_clientinfo *, int, char **);
void w2c_chan(struct w2c_clientinfo *, int, char **);
void w2c_delclient(struct w2c_clientinfo *);
struct w2c_clientinfo *w2c_findclient(int);
void w2c_addclient(int, char *);
void w2c_readsocks(void);
void w2c_checksocks(void);
void w2c_initsocket(void);
void w2c_sendrpl(struct w2c_clientinfo *, const char *, ...);

struct w2c_commands w2c_cmds[] = {
 /* cmd,            function,             niveau, needarg, chan, 0 */
 {  "LOGIN",		w2c_login,				0,		2, 0 },
 {	"PONG",			w2c_pong,				0,		1, 0 },
 {	"MODUSER",		w2c_moduser,			5,		3, 1 },
 {	"CHANINFO",		w2c_chaninfo,			1,		1, 1 },
 {	"ACCESS",		w2c_access,				1,		1, 1 },
 {	"SET",			w2c_set,				1,		1, 0 },
 {	"USER", 		w2c_user,				1,		1, 0 },
 {	"CHAN",			w2c_chan,				1,		2, 0 },
 {  "",				NULL,					0,		0, 0 }
};

