/* src/admin_manage.c - commandes pr gerer les admins
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <main.h>
#include <time.h>

CVSINFO("$Id: admin_manage.c,v 1.3 2003/03/02 16:39:33 progs Exp $");

/*
 * do_admin
 *
 * parv[1] = pseudo
 * parv[2] = niveau
 */
void do_admin(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	anUser *user;
	unsigned int niveau;
#ifdef USE_MEMOSERV
	char memo[MEMOLEN];
#endif

	if(!is_num(parv[2]))
	{
		csntc(nick, "Le niveau doit tre une valeur numrique");
		return;
	}
	niveau = atoi(parv[2]);
	if(niveau > 4 || niveau < 2)
	{
		csntc(nick, "Le niveau des admins doit tre entre 2 et 4.");
		return;
	}
	if(!(user = getuserinfo(parv[1])))
	{
		csntc(nick, NOSUCHUSER, parv[1]);
		return;
	}
	if(IsAnAdmin(user))
	{
		csntc(nick, "%s est dj Admin (Utilisez ADMINLVL pour changer son niveau).", user->nick);
		return;
	}
	user->level = niveau;
	csntc(nick, "%s est maintenant admin de niveau %d", user->nick, user->level);
#ifdef USE_MEMOSERV
	snprintf(memo, MEMOLEN, "Flicitations ! %s vous a mis \002Administrateur des Services\002 au niveau %d !", nick->nick, user->level);
	add_memo(user, "Services", time(NULL), memo);
#endif
	write_anuser(user);
	return;
}

/*
 * admin_level
 *
 * parv[1] = username
 * parv[2] = niveau
 */
void admin_level(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	anUser *user;
	int niveau, last;
#ifdef USE_MEMOSERV
	char memo[MEMOLEN];
#endif

	if(!is_num(parv[2]))
	{
		csntc(nick, "Le niveau doit tre un nombre.");
		return;
	}
	niveau = atoi(parv[2]);
	if(niveau > 4 || niveau < 2)
	{
		csntc(nick, "Le niveau des admins doit tre entre 2 et 4.");
		return;
	}
	if(!(user = getuserinfo(parv[1])))
	{
		csntc(nick, NOSUCHUSER, parv[1]);
		return;
	}
	if(!IsAnAdmin(user))
	{
		csntc(nick, "%s n'est pas Admin.", user->nick);
		return;
	}
	if(nick->user && niveau >= nick->user->level && nick->user->level != 4)
	{
		csntc(nick, "Vous ne pouvez pas mettre %s  un niveau suprieur ou gal au votre.", user->nick);
		return;
	}
	last = user->level;
	if(last == niveau)
	{
		csntc(nick, "%s est dj au niveau %d !", user->nick, niveau);
		return;
	}
	user->level = niveau;
	csntc(nick, "%s a maintenant le niveau %d", user->nick, user->level);

#ifdef USE_MEMOSERV
	if(last < niveau)
		snprintf(memo, MEMOLEN, "Flicitations ! %s a chang votre niveau d'Admin en %d !", nick->nick, user->level);
	else
		snprintf(memo, MEMOLEN, "Dommage ! %s a chang votre niveau d'Admin en %d :(", nick->nick, user->level);
	add_memo(user, "Services", time(NULL), memo);
#endif

	write_anuser(user);
	return;
}

/*
 * del_admin
 *
 * parv[1] = pseudo
 */
void del_admin(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	anUser *user;
#ifdef USE_MEMOSERV
	char memo[MEMOLEN];
#endif

	if(!(user = getuserinfo(parv[1])))
	{
		csntc(nick, NOSUCHUSER, parv[1]);
		return;
	}
	if(!IsAnAdmin(user))
	{
		csntc(nick, "%s n'est pas Admin", user->nick);
		return;
	}
	user->level = 1;
	csntc(nick, "%s n'est plus Admin", user->nick);

#ifdef USE_MEMOSERV
	snprintf(memo, MEMOLEN, "Dsol, vous n'tes plus Administrateur des Services. (Accs supprim par %s)", nick->nick);
	add_memo(user, "Services", time(NULL), memo);
#endif

	write_anuser(user);
}
