/* src/cs_register.c - Enregistrement de salon
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <unistd.h>
#include <time.h>
#include <main.h>

CVSINFO("$Id: cs_register.c,v 1.7 2003/02/23 14:45:27 romexzf Exp $");

/*
 * register_chan
 *
 * parv[1] = salon
 * parv[2-parc] = description
 */
void register_chan(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *salon = parv[1], description[200];
	aChan *c;
	struct joininfo *chan;
	int flag = 0;

	if(!chan_check(salon, nick)) return;
	if(!nick->user)
	{
	csntc(nick, "Pour utiliser cette commande vous devez vous identifier sous votre username (Commande LOGIN)");
		return;
	}

	parv2msgn(parc, parv, 2, description, 200);
	if(strlen(description) < 12)
	{
			csntc(nick, "La longueur de la description doit tre de plus de 12 charactres.");
			return;
	}
	if(!IsAnAdmin(nick->user) && IsAnOwner(nick->user->nick))
	{
		csntc(nick, "\002Vous ne pouvez pas avoir plusieurs salons.");
		return;
	}
	if(IsRegChan(salon))
	{
		csntc(nick, "\002%s est dj enregistr", salon);
		return;
	}

	chan = getjoininfo(nick, salon);
	if(!chan || !chan->is_op)
	{
		csntc(nick, "Vous devez tre Op sur %s pour l'enregistrer.", salon);
		return;
	}

	flag |= (A_OP & A_PROTECT);

	c = add_chan(salon, "+nt", "", description, "+nt", "", "" , "", 0, 100, 1, "", "");
	add_access(nick->user, salon, 500, flag, "", time(NULL));
	csjoin(c);
	csmode(c, "+ont %s", cs.num);
	putlog(LOG_CHANS, "REGCHAN %s par %s@%s (%s)\n", salon, nick->nick, nick->user->nick, description);
	csntc(nick, "Le salon %s est maintenant enregistr et vous appartient", salon);
	append_file(CHANS_FILE,c->chan);
	write_achan(c);
	write_anuser(nick->user);
	return;
}

/*
 * ren_chan
 *
 * parv[1] = chan
 * parv[2] = nouveau chan
 */
void ren_chan(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aChan *c = NULL, *c2;
	aLink *access;
	char *chan = parv[1], *newchan = parv[2], path1[250], path2[250], old[200], new[200], *tmp;

	if(!chan_check(newchan, nick)) return;

	if((c2=getchaninfo(newchan)))
	{
		csntc(nick, "Le salon \002%s\002 est dj enregistr", c2->chan);
		return;
	}
	c=chaninfo;

	cspart(c->chan, "Nom chang en \002%s\002 - %s@%s", newchan, nick->nick, nick->user->nick);
	putlog(LOG_CHANS, "RENCHAN %s %s par %s@%s\n", c->chan, newchan, nick->nick, nick->user->nick);
	strcpy(c->chan, newchan);
	c->members=NULL;
	csjoin(c);
	tmp = c->defmodes;
	if(*tmp == '+') tmp++;
	csmode(c, "+o%s %s", tmp, cs.num);
	write_chanlist();

	for(access = c->access;access;access=access->next)
	{
		strcpy(access->value.a->chan, newchan);
		write_anuser(access->value.a->user);
	}

	conv_char(chan, old);
	conv_char(newchan, new);
	snprintf(path1, 250, "database/chans/%s", old);
	snprintf(path2, 250, "database/chans/%s", new);
	rename(path1, path2);

	csntc(nick, "Le nom du salon %s est maintenant %s", chan, newchan);
	return;
}

/*
 * unreg_chan
 *
 * parv[1] = salon
 * parv[parc-1] = raison
 */
void unreg_chan(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *salon = parv[1], raison[150];

	if(nick->user && !IsOwner(nick->user->nick, salon))
	{
		csntc(nick, "Vous devez tre le propritaire du salon pour le supprimer.");
		return;
	}
	if(!CWantUnreg(chaninfo))
	{
		SetCWantUnreg(chaninfo);
		csntc(nick, "Etes vous sur de vouloir dsenregistrer votre salon (%s), cette opration est \2irrversible\2.", chaninfo->chan);
		csntc(nick, "Pour annuler, tapez \2/%s UNREG %s NON\2 pour confirmer, tapez \2/%s UNREG %s OUI\2", cs.nick, chaninfo->chan, cs.nick, chaninfo->chan);
		return;
	}
	if(parc < 2 || (strcasecmp(parv[2],"oui") && strcasecmp(parv[2],"non")))
	{
		csntc(nick, "Salon en cours d'unreg: pour annuler, tapez \2/%s UNREG %s NON\2 pour confirmer, tapez \2/%s UNREG %s OUI\2", cs.nick, chaninfo->chan, cs.nick, chaninfo->chan);
		return;
	}
	if(!strcasecmp(parv[2],"non"))
	{
		csntc(nick, "Procdure d'unreg annule.");
		DelCWantUnreg(chaninfo);
		return;
	}
	if(parc > 2) parv2msgn(parc, parv, 3, raison, 150);
	else strcpy(raison, "Aucune raison");

	csntc(nick, "Le salon %s a bien t dsenregistr", salon);
	putlog(LOG_CHANS, "UNREG %s par %s@%s (%s)\n", salon, nick->nick, nick->user->nick, raison);
	cspart(salon, "Salon dsenregistr par %s -\002 %s", nick->nick, raison);
	cswallops("Le salon %s a t dsenregistr par %s -\002 %s", salon, nick->nick, raison);
	del_chan(salon);
	return;
}
