/* src/vote.c - Effectuer un vote
 * Copyright (C) 2002-2003 Inter System (Progs@Inter-System.Net)
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <main.h>

CVSINFO("$Id: vote.c,v 1.5 2003/03/02 16:39:33 progs Exp $");

#ifdef HAVE_VOTE
struct votes vote[20];
char vote_topic[MEMOLEN];
int vote_actif=0;
int vote_nbprop=0;
int intbuf[20];

static int *class_votes(int prout[])
{
	unsigned int i, isgood=0;
	for(i=0;i<= vote_nbprop;i++) intbuf[i] = i;
	while(!isgood)
	{
		isgood = 1;
		for(i=0;i<= vote_nbprop;i++)
		{
			if(i+1 > vote_nbprop) break;
			if(prout[i] < prout[i+1])
			{
				int j;
				j = prout[i+1];
				prout[i+1] = prout[i];
				prout[i] = j;
				j = intbuf[i+1];
				intbuf[i+1] = intbuf[i];
				intbuf[i] = j;
				isgood = 0;
			}
		}
	}
	return intbuf;
}

void show_vote(aNick *nick)
{
	unsigned int i=0;
	csntc(nick, "\37\2Sujet\37:\2 %s", vote_topic);
	csntc(nick, "\37\2Propositions\37:\2");
	for(;strcmp(vote[i].prop, "end");i++) csntc(nick, "%d. %s", i+1, vote[i].prop);
}
/*
 * vote_results
 */
void vote_results(aNick *nick, aChan *c, int parc, char **parv)
{
	float f=0;
	int i, prout[20], *sex;

	if(vote_actif)
	{
		csntc(nick, "Vous ne pouvez pas voir les rsultats, le vote est encore en cours !");
		return;
	}
	if(!vote_nbprop)
	{
		csntc(nick, "Aucun vote existant");
		return;
	}
	csntc(nick, "\37\2Sujet\37:\2 %s", vote_topic);
	csntc(nick, "Rsultats:");
	for(i=0;strcmp(vote[i].prop, "end");i++)
	{
		f += vote[i].voies;
		prout[i] = vote[i].voies;
	}
	sex = class_votes(prout);
	for(i=0;i <= vote_nbprop;i++) csntc(nick, "%d. %3.2f%c [%d] \2%s", i+1, (vote[sex[i]].voies/f) * 100, '%', vote[sex[i]].voies, vote[sex[i]].prop);
	return;
}

/*
 * voter
 *
 * parv[1] = n de la proposition
 */
void voter(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	int nb_prop=0;

	if(!vote_actif)
	{
		if(!vote_nbprop)
		{
			csntc(nick, "Le vote n'est pas actif");
			return;
		}
		else
		{
			csntc(nick, "Le vote est clos. Pour voir les rsultats, tapez /%s RESULTS", cs.nick);
			return;
		}
	}

	if(!parc)
	{
		csntc(nick, "Un vote est actuellement en cours.");
		show_vote(nick);
		if(nick->user && !nick->user->vote) csntc(nick, "Pour votez utilisez: \2/%s VOTER <n de la proposition>\2", cs.nick);
		return;
	}

	if(nick->user->vote == -1)
	{
		csntc(nick, "Vous avez enregistr votre username aprs l'ouverture du vote. Vous ne pourrez voter qu'au prochain vote");
		return;
	}

	if(nick->user->vote)
	{
		csntc(nick, "Vous avez dj vot !");
		return;
	}
	if(!is_num(parv[1]))
	{
		csntc(nick, "Le n de la proposition doit tre une valeur numrique");
		return;
	}
	nb_prop=atoi(parv[1]);
	if(nb_prop < 1 || --nb_prop > vote_nbprop)
	{
		csntc(nick, "Les propositions vont de 1  %d", (1+vote_nbprop));
		return;
	}
	nick->user->vote = (nb_prop+1);
	vote[nb_prop].voies++;
	csntc(nick, "Votre vote pour \2%s\2 a bien t pris en compte !", vote[nb_prop].prop);
	write_votes();
	write_anuser(nick->user);
	return;
}

/*
 * vote
 *
 * - parv[1] = "NEW" :
 *     parv[2] = nb de choix
 *     parv[3] = :sujet du vote
 * - parv[1] = "PROPOSITION" :
 *     parv[2] = :nom de la proposition
 * - parv[1] = "CLORE" : (arrete le vote)
 * - parv[1] = "RESULTS" : (voir les rsultats)
 */
void do_vote(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *cmd = NULL;

	if(!parc)
	{
		csntc(nick, "Le vote est \2%sACTIF\2", vote_actif ? "" : "IN");
		if(vote_nbprop) show_vote(nick);
		return;
	}

	cmd=parv[1];

	if(!strcasecmp(cmd, "NEW"))
	{
		anUser *u;
		char tmp[500], *msg = NULL;
		if(parc < 3)
		{
			csntc(nick, "Syntaxe: VOTE NEW <nombre de propositions> :<sujet>");
			return;
		}
		if(vote_actif)
		{
			csntc(nick, "Le vote est dj actif");
			return;
		}
		if(!is_num(parv[2]))
		{
			csntc(nick, "Le nombre de proposition doit tre une valeur numrique");
			return;
		}
		if(atoi(parv[2]) < 2 || atoi(parv[2]) > 20)
		{
			csntc(nick, "Il peut y avoir de 2  20 propositions possibles");
			return;
		}
		parv2msgn(parc, parv, 3, tmp, 500);
		msg=tmp;
		if(*msg==':') msg++;
		if(strlen(msg) > MEMOLEN)
		{
			csntc(nick, "La longueur du sujet du vote ne doit pas dpasser %d caractres", MEMOLEN);
			return;
		}
		strncpy(vote_topic, msg, MEMOLEN);
		vote_nbprop=atoi(parv[2]);
		vote_nbprop--;
		for(u=userhead;u;u=u->next) u->vote = 0;
		csntc(nick, "Le vote est en cours de cration.");
		csntc(nick, "\37\2Sujet\37:\2 %s", vote_topic);
		csntc(nick, "Vous devez maintenant dfinir les propositions avec : \37\2/%s VOTE PROPOSITION :<nom>\37\2 jusqu' que vous ayez donn les %d propositions", cs.nick, vote_nbprop+1);
		strcpy(vote[0].prop, "end");
		return;
	}
	if(!strcasecmp(cmd, "PROPOSITION"))
	{
		int i;
		char *msg = NULL, tmp[500];
		if(parc < 2)
		{
			csntc(nick, "Syntaxe: VOTE PROPOSITION :<proposition>");
			return;
		}
		if(vote_actif)
		{
			csntc(nick, "Le vote est dj actif");
			return;
		}
		if(!vote_nbprop)
		{
			csntc(nick, "Aucun vote n'est en cours d'enregistrement");
			return;
		}
		for(i=0;strcmp(vote[i].prop, "end");i++);
		if(i>vote_nbprop)
		{
			csntc(nick, "Vous avez bien donn toutes les propositions pour le vote");
			return;
		}
		parv2msgn(parc, parv, 2, tmp, 500);
		msg = tmp;
		if(*msg==':') msg++;
		if(!strcmp(msg, "end"))
		{
			csntc(nick, "Vous ne pouvez pas donner comme message \"%s\"", msg);
			return;
		}
		if(strlen(msg) > MEMOLEN)
		{
			csntc(nick, "La longueur de la proposition ne doit pas dpasser %d caractres", MEMOLEN);
			return;
		}
		strncpy(vote[i].prop, msg, MEMOLEN);
		vote[i].voies = 0;
		strcpy(vote[(i+1)].prop, "end");
		if(i==vote_nbprop)
		{
			vote_actif=1;
			csntc(nick, "Le vote est maintenant \2ACTIF\2.");
			show_vote(nick);
			write_votes();
			return;
		}
		csntc(nick, "Vous avez donn %d des %d propositions.", i+1, vote_nbprop+1);
		return;
	}
	if(!strcasecmp(cmd, "CLORE"))
	{
		if(!vote_actif)
		{
			csntc(nick, "Pas de vote actif");
			return;
		}
		vote_actif=0;
		csntc(nick, "Le vote est clos. Les users peuvent maintenant voir les rsultats");
		write_votes();
		return;
	}
	if(!strcasecmp(cmd, "RESULTS"))
	{
		anUser *u;
		int i, prout[20], *sex, usr=0;
		float f=0;

		if(!vote_nbprop)
		{
			csntc(nick, "Aucun vote existant");
			return;
		}

		csntc(nick, "Rsultats:");

		for(i=0;strcmp(vote[i].prop, "end");i++)
		{
			f += vote[i].voies;
			prout[i] = vote[i].voies;
		}
		sex = class_votes(prout);
		for(i=0;i <= vote_nbprop;i++) csntc(nick, "%d. %3.2f%c [%d] \2%s", i+1, (vote[sex[i]].voies/f) * 100, '%', vote[sex[i]].voies, vote[sex[i]].prop);
		for(u=userhead;u;u=u->next) usr++;
		csntc(nick, "%1.0f des %d users ont vots (%3.2f%c)", f, usr, (f/usr) * 100, '%');
		return;
	}
	csntc(nick, "La sous commande %s n'existe pas", cmd);
	csntc(nick, "Syntaxe: VOTE NEW <nombre de propositions> :<sujet>");
	csntc(nick, "        VOTE PROPOSITION :<proposition>");
	csntc(nick, "        VOTE CLORE");
	csntc(nick, "        VOTE RESULTS");
	return;
}
#endif
